/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef __dctcat_h__
#define __dctcat_h__

#include <stream.h>
#include <Unidraw/Commands/command.h>

class PopupMenu;
class Command;
class TextGraphic;
class PinComp;
class PinView;
class UList;
class Line;
class FileChooser;

//----------------------commands for the menu----------------------

class DctNewCompCmd : public Command
{
public:
	DctNewCompCmd(ControlInfo*, Component* prototype = nil);
	DctNewCompCmd(Editor* = nil, Component* prototype = nil);
	virtual ~DctNewCompCmd();
 
    virtual void Execute();
	virtual boolean Reversible();
	Component* GetPrototype();
    virtual Command* Copy();
	virtual void Read(istream&);
	virtual void Write(ostream&);
	virtual ClassId GetClassId();
	virtual boolean IsA(ClassId);
private:
	Component* prototype_;
};

inline Component* DctNewCompCmd::GetPrototype () { return prototype_; }

class DctSaveCompCmd : public Command
{
public:
    DctSaveCompCmd(ControlInfo*);
    DctSaveCompCmd(Editor* = nil);
 
    virtual void Execute();
    virtual boolean Reversible();
    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

class DctSaveCompAsCmd : public Command
{
public:
    DctSaveCompAsCmd(ControlInfo*);
    DctSaveCompAsCmd(Editor* = nil);
    virtual ~DctSaveCompAsCmd();
 
    virtual void Execute();
    virtual boolean Reversible();
    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

class DctSaveCompAsVdctCmd : public Command
{
public:
    DctSaveCompAsVdctCmd(ControlInfo*);
    DctSaveCompAsVdctCmd(Editor* = nil);
    virtual ~DctSaveCompAsVdctCmd();
 
    virtual void Execute();
    virtual boolean Reversible();
    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

class DctViewCompCmd : public Command
{
public:
    DctViewCompCmd(ControlInfo*);
    DctViewCompCmd(Editor* = nil);
    virtual ~DctViewCompCmd();
 
    virtual void Execute();
    virtual boolean Reversible();
    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

#endif
