/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#include "dctclasses.h"
#include "dctcreat.h"
#include "dctrec.h"
#include "dcted.h"
#include "dctext.h"
#include "dctvars.h"
#include "dctmanip.h"
#include "dctcmds.h"
#include "dctcat.h"
#include "dctcomps.h"

#include <Unidraw/catalog.h>
  
#include <stream.h>
#include <string.h>

// ------------------------creator stuff-------------------------
dct_creator::dct_creator() {}
 
void* dct_creator::Create(ClassId id, istream& in,ObjectMap* objmap,int objid)
{
    switch(id)
    {
        case REC_COMP: CREATE(RecComp,in,objmap,objid); break;
        case EXTLINK_COMP: CREATE(ExtLinkComp,in,objmap,objid); break;
        case NODE_COMP: CREATE(NodeComp,in,objmap,objid); break;
		case EXAMINE_TOOL: CREATE(ExamineTool, in, objmap, objid); break;
		case FIELDEDIT_CMD: CREATE(FieldEditCmd, in, objmap, objid); break;
		case RENAMEREC_CMD: CREATE(RenameRecCmd, in, objmap, objid); break;
		case LINKFIELD_CMD: CREATE(LinkFieldCmd, in, objmap, objid); break;
		case NODE_VAR: CREATE(NodeVar, in, objmap, objid); break;
		case PVLINK_VAR: CREATE(PVLinkVar, in, objmap, objid); break;
		case FIELDEXPORT_CMD: CREATE(FieldExportCmd, in, objmap, objid); break;
		case WIRE_COMP: CREATE(WireComp, in, objmap, objid); break;
		case IMPORTREC_CMD: CREATE(ImportRecCmd, in, objmap, objid); break;
		case NOWHEREEDIT_CMD: CREATE(NowhereEditCmd, in, objmap, objid); break;
		case DCTGRAPHIC_COMPS: CREATE(DctGraphicComps, in, objmap,objid); break;
		case DCTNEWCOMP_CMD: CREATE(DctNewCompCmd, in, objmap, objid); break;
		case DCTSAVECOMP_CMD: CREATE(DctSaveCompCmd, in, objmap, objid); break;
		case DCTSAVECOMPAS_CMD: CREATE(DctSaveCompAsCmd,in,objmap,objid); break;
		case DCTSAVECOMPASVDCT_CMD: CREATE(DctSaveCompAsVdctCmd,in,objmap,objid); break;
		case DCTVIEWCOMP_CMD: CREATE(DctViewCompCmd, in, objmap, objid); break;
        default:
            void* ptr;
            ptr = Creator::Create(id,in,objmap,objid);
            return ptr;
    }
}
 
void* dct_creator::Create(ClassId id)
{
	if(id==REC_VIEW) return new RecView;
	else if(id==NODE_VIEW) return new NodeView;
	else if(id==WIRE_VIEW) return new WireView;
	else if(id==EXTLINK_VIEW) return new ExtLinkView;
	else if(id==DCTGRAPHIC_VIEWS) return new DctGraphicViews;

	else if(id==PS_DCTGRAPHIC) return new PostScriptViews;
    else
	{
		void* ptr = Creator::Create(id);
		return ptr;
	}
}

