/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef dctnewrec_h
#define dctnewrec_h

#include <Unidraw/dialogs.h>
#include <InterViews/button.h>

class NewRecDialog;
class StringEditor;
class StringBrowser;

class NewRecBS : public ButtonState
{
public:
	NewRecBS(int);

	void SetEdit(NewRecDialog* ne) { newrec_dialog=ne; }
	virtual void Notify();
private:
	NewRecDialog* newrec_dialog;
};

class NewRecDialog: public BasicDialog
{
public:
	NewRecDialog(const char* title);
	virtual ~NewRecDialog();

	boolean GetData();
	void perform_update(int);
	Interactor* AddScroller(Interactor*);
	boolean GetEntry(char*& rectype, char*& recname);

private:
	NewRecBS* main_bs;

	PushButton* create_pb;
	PushButton* done_pb;
	PushButton* show_pb;

	StringEditor* rec_se;
	StringBrowser* rec_sb;
	StringBrowser* type_sb;
};

#endif

