/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef dctnowhere_h
#define dctnowhere_h

#include <InterViews/button.h>

class NowhereEdit;
class StringEditor;
class StringBrowser;

class NowhereBS : public ButtonState
{
public:
	NowhereBS(int);

	void SetEdit(NowhereEdit* ne) { nowhere_edit=ne; }
	virtual void Notify();
private:
	NowhereEdit* nowhere_edit;
};

class NowhereEdit: public BasicDialog
{
public:
	NowhereEdit(const char* title);
	virtual ~NowhereEdit();

	void GetData();
	void perform_update(int);
	Interactor* AddScroller(Interactor*);
private:
	NowhereBS* main_bs;
	PushButton* rename_pb;
	PushButton* delete_pb;
	PushButton* copy_pb;
	PushButton* edit_pb;
	PushButton* done_pb;
	PushButton* show_pb;
	StringEditor* rec_se;
	StringBrowser* rec_sb;
	StringBrowser* type_sb;
};

#endif

